Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.javascript.ast
Class LetNode

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.Jump
                  org.mozilla.javascript.ast.Scope
                      org.mozilla.javascript.ast.LetNode

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class LetNode

extends Scope

AST node for let statements and expressions. Node type is `Token.LET` or `Token.LETEXPR`.

     LetStatement:
         let ( VariableDeclarationList ) Block
     LetExpression:
         let ( VariableDeclarationList ) Expression

Note that standalone let-statements with no parens or body block, such as `let x=6, y=7;`, are represented as a `VariableDeclaration` node of type `Token.LET`, wrapped with an `ExpressionStatement`.

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.Scope
`parentScope, symbolTable, top`

Fields inherited from class org.mozilla.javascript.ast.Jump
`target`

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node
`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`LetNode()`
`LetNode(int pos)`
`LetNode(int pos, int len)`

Method Summary
`AstNode` | `getBody()` Returns body statement or expression.
`int` | `getLp()` Returns left paren position, -1 if missing
`int` | `getRp()` Returns right paren position, -1 if missing
`VariableDeclaration` | `getVariables()` Returns variable list
`void` | `setBody(AstNode body)` Sets body statement or expression.
`void` | `setLp(int lp)` Sets left paren position
`void` | `setParens(int lp, int rp)` Sets both paren positions
`void` | `setRp(int rp)` Sets right paren position
`void` | `setVariables(VariableDeclaration variables)` Sets variable list.
`java.lang.String` | `toSource(int depth)` Emits source code for this node.
`void` | `visit(NodeVisitor v)` Visits this node, the variable list, and if present, the body expression or statement.

Methods inherited from class org.mozilla.javascript.ast.Scope
`addChildScope, clearParentScope, getChildScopes, getDefiningScope, getParentScope, getStatements, getSymbol, getSymbolTable, getTop, joinScopes, putSymbol, replaceWith, setParentScope, setSymbolTable, setTop, splitScope`

Methods inherited from class org.mozilla.javascript.ast.Jump
`getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node
`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LetNode

    public LetNode()

### LetNode

    public LetNode(int pos)

### LetNode

    public LetNode(int pos,
                   int len)

Method Detail

### getVariables

    public VariableDeclaration getVariables()

  Returns variable list

### setVariables

    public void setVariables(VariableDeclaration variables)

  Sets variable list. Sets list parent to this node.

  Throws:
    `java.lang.IllegalArgumentException` - if variables is `null`

### getBody

    public AstNode getBody()

  Returns body statement or expression. Body is `null` if the form of the let statement is similar to a VariableDeclaration, with no curly-brace. (This form is used to define let-bound variables in the scope of the current block.)

  Returns:
    the body form

### setBody

    public void setBody(AstNode body)

  Sets body statement or expression. Also sets the body parent to this node.

  Parameters:
    `body` - the body statement or expression. May be `null`.

### getLp

    public int getLp()

  Returns left paren position, -1 if missing

### setLp

    public void setLp(int lp)

  Sets left paren position

### getRp

    public int getRp()

  Returns right paren position, -1 if missing

### setRp

    public void setRp(int rp)

  Sets right paren position

### setParens

    public void setParens(int lp,
                          int rp)

  Sets both paren positions

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Overrides:
    `toSource` in class `Scope`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, the variable list, and if present, the body expression or statement.

  Overrides:
    `visit` in class `Scope`
  Parameters:
    `v` - the object to call with this node and its children

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD